#!/bin/sh

# reset opera_home/jsplugins* links so this can run as
# an install script from minidock+usb or ssh
if [ -L /mnt/system/opera_home/jsplugins ]; then
  rm -f /mnt/system/opera_home/jsplugins
fi
if [ -d /mnt/system/opera_home/jsplugins ]; then
  rm -fr /mnt/system/opera_home/jsplugins
  rm -f /mnt/system/opera_home/jsplugins* # clean up any renamed entries
fi
ln -s /mnt/data/jsplugins /mnt/system/opera_home/jsplugins

# ensure dohack.html exists for starting Opera without wifi
if [ ! -f /mnt/data/dohack.html ]; then
  echo "HACK SCRIPT SHOULD BE RUNNING, AVOS MAY BE RESTARTING (CHECK DISK ACTIVITY LIGHT), DO NOT PRESS ANY BUTTONS" > /mnt/data/dohack.html
fi

# if arcwelder is installed, start sshd
if [ -d /mnt/data/Data/arcwelder ]; then
  if [ ! -d /tmp/ssh ]; then
    sh -x /mnt/data/Data/arcwelder/install
  fi
  if [ "`pidof sshd`x" = "x" ]; then
    /tmp/ssh/sshd -f /tmp/ssh/sshd_config
  fi
fi

HACKDIR=/mnt/system/hack
VERSION=beta2
# check if $HACKDIR/$VERSION has been created
if [ ! -f "$HACKDIR/$VERSION" ]; then
  
  if [ -d "$HACKDIR" ]; then rm -fr "$HACKDIR"; fi
  mkdir "$HACKDIR"
  cp -a /sbin "$HACKDIR"

  # modify poweroff and reboot so they rename jsplugins before shutdown
  rm "$HACKDIR"/sbin/poweroff
  rm "$HACKDIR"/sbin/reboot

cat > "$HACKDIR"/sbin/poweroff <<EOF
#!/bin/sh
if [ -d /mnt/data/jsplugins ]; then /bin/mv /mnt/data/jsplugins /mnt/data/jspluginsx; fi
/bin/busybox poweroff
EOF

cat > "$HACKDIR"/sbin/reboot <<EOF
#!/bin/sh
if [ -d /mnt/data/jsplugins ]; then /bin/mv /mnt/data/jsplugins /mnt/data/jspluginsx; fi
/bin/busybox reboot
EOF

  chmod +x "$HACKDIR"/sbin/poweroff
  chmod +x "$HACKDIR"/sbin/reboot

  touch "$HACKDIR/$VERSION"
fi

# mount /sbin on $HACKDIR/sbin if not already mounted
if [ "`mount | sed -n '/sbin/p'`x" = "x" ]; then
  mount -o bind "$HACKDIR"/sbin /sbin
fi

# rename the jsplugins directory so hack can survive a reboot
if [ -d /mnt/data/jsplugins ]; then mv /mnt/data/jsplugins /mnt/data/jspluginsx; fi

# if NES emulator fce ultra is present, run that instead of restarting avos
if [ -d /mnt/data/fceu ]; then
  killall -SIGSTOP avos
  export LD_LIBRARY_PATH=/mnt/data/fceu
  export SDL_NOMOUSE=1
  export HOME=/mnt/data/fceu
  cp /mnt/data/fceu/transparency77 /dev/fb2
  /mnt/data/fceu/stopstart.sh &
  /mnt/data/fceu/fceu -sound 0 -fs 1 -bpp 16 -xres 800 -yres 480 -nofs 1 -frameskip 2 /mnt/data/fceu/game.nes >/dev/null 2>&1
  killall -SIGCONT avos
  exit 0
fi

# setup qtopia from openpma if required (and exit)
if [ -f /mnt/data/openpma-ng.sh ]; then
  /mnt/data/openpma-ng.sh --install
  chown -R nobody:nobody /home/nobody
  exit 0
fi

# if restartavos.sh is not present then exit
if [ ! -f /mnt/data/restartavos.sh ]; then exit 0; fi

# if original avos is not running then don't restart
if [ "`pidof avos_helper.sh`x" = "x" ]; then exit 0; fi

## REMOVE THESE LINES BELOW IF YOU NEVER WANT TO RESTART AVOS
if [ "`pidof sshd`x" = "x" ]; then 
  /mnt/data/nohup /mnt/data/restartavos.sh >/dev/null 2>&1
else
  /mnt/data/ssh -f -o StrictHostKeyChecking=no 127.0.0.1 /mnt/data/restartavos.sh >/dev/null 2>&1
fi
